/*
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 * Copyright (C) 2007 Dr. Ruediger Berlich - ruediger@berlich.de
 */

// Compile with "g++ -o bind1 bind1.cpp"
// Tested on OpenSUSE 10.2, g++ 4.12, boost 1.33.1

#include <boost/bind.hpp>

#include <functional>
#include <iostream>

using namespace std;
using namespace boost;

/******************************************************************************/

int main(int argc, char** argv){
    // Setzen Sie y auf 7 und beobachten Sie den Unterschied
    int x = 5, y = 3;

    // Argumentbindung std::bind2nd
    cout << "Test of std::bind2nd :" << endl;
    if(bind2nd(less<int>(),x)(y)) 
	cout << x << " is smaller than " << y << endl;
    else
	cout << x << " is geater or equal to " << y << endl;

    // Argumentbinding mit boost::bind
    cout << "Test of boost::bind :" << endl;
    if(bind(std::less<int>(), _1, x)(y))
	cout << x << " is smaller than " << y << endl;
    else
	cout << x << " is geater or equal to " << y << endl;
}
 
/******************************************************************************/

